<?php

	// 設定
	$client_id = '' ;		// クライアントID
	$client_secret = '' ;		// クライアントシークレット
	$callback_url = 'http://.../myscript.php' ;		// コールバックURL
	$verify_token = 'aikotoba' ;		// 合い言葉となるキー

	// 登録時の、Instagram側の確認用アクセスを受ける
	if( $_SERVER['REQUEST_METHOD'] == 'GET' && isset($_GET['hub_verify_token']) && $_GET['hub_verify_token'] == $verify_token && isset($_GET['hub_challenge']) && isset($_GET['hub_mode']) && $_GET['hub_mode'] == 'subscribe' )
	{
		// 確認用のキーを返却する
		echo $_GET[ 'hub_challenge' ] ;
		exit ;
	}
 
	// パラメータを連想配列形式で指定(サンプルはGeographyの場合)
	$params = array(
		'client_id' => $client_id ,
		'client_secret' => $client_secret ,
		'object' => 'geography' ,
		'aspect' => 'media' ,
		'lat' => '35.798535' ,
		'lng' => '139.7940011' ,
		'radius' => '1000' ,
		'verify_token' => $verify_token ,
		'callback_url' => $callback_url ,
	) ;

	// POSTリクエストを送信し、返ってきたJSONデータをオブジェクト形式に変換
	// JSONデータが返ってくる前に待たされて、8〜13行目が行なわれる
	$json = @file_get_contents(
		'https://api.instagram.com/v1/subscriptions/' ,
		false,stream_context_create( array( 'http' => array(
			'method' => 'POST' ,
			'content' => http_build_query( $params ) ,
		)))
	) ;

	// 取得したJSONをオブジェクトに変換
	$obj = json_decode( $json ) ;
 
	// 各データの整理
	$id = $obj->data->id ;		// 通知ID
	$url = 'https://api.instagram.com/v1/subscriptions?client_id=' . $params['client_id'] . '&client_secret=' . $params['client_secret'] ;		// 登録状況の確認用URL

	// HTML用
	$html = '' ;

	// 取得したデータ
	$html .= '<h2>取得したデータ</h2>' ;
	$html .= '<p>リアルタイム通知を登録しました。通知IDは<mark>' . $id . '</mark>です。</p>" : "<p>登録に失敗しました…。パラメータがおかしいか、重複登録です。</p>' ;
	$html .= 	'<h3>JSON</h3>' ;
	$html .= 	'<p><textarea rows="8">' . $json . '</textarea></p>' ;
	$html .= 	'<h3>登録状況の確認</h3>' ;
	$html .= 	'<p><a href="' . $url . '" target="_blank">' . $url . '</a></p>' ;

?><!DOCTYPE html>
<html>
	<head>
		<meta charset="UTF-8">
		<meta name="robots" content="noindex,nofollow">

		<!-- ビューポートの設定 -->
		<meta name="viewport" content="width=device-width, initial-scale=1.0">

		<title>InstagramでリアルタイムAPIの通知を登録するサンプルデモ</title><!-- 

/********************************************************************************

	SYNCER 〜 知識、感動をみんなと同期(Sync)するブログ

	* 配布場所
	https://syncer.jp/instagram-api-matome

	* 動作確認
	https://syncer.jp/instagram-api-matome/demo/regist-realtime.php

	* 最終更新日時
	2015/07/28 02:49

	* 作者
	あらゆ

	** 連絡先
	Twitter: https://twitter.com/arayutw
	Facebook: https://www.facebook.com/arayutw
	Google+: https://plus.google.com/114918692417332410369/
	E-mail: info@syncer.jp

	※ バグ、不具合の報告、提案、ご要望など、お待ちしております。
	※ 申し訳ありませんが、ご利用者様、個々の環境における問題はサポートしていません。

********************************************************************************/

		-->
	</head>
<body>



<?php echo $html ?>


<p style="text-align:center"><a href="https://syncer.jp/instagram-api-matome">配布元: Syncer</a></p>






</body>
</html>
